<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2007 Tim Lochmueller, Sareen Millet
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

class tx_flrealurlimage {
	
	/*
	 * Hook method for realurl image decode
	 *
	 * @return -
	 */
	function checkImageDecode(&$params, $ref) {
		$decode = t3lib_div::makeInstance('tx_flrealurlimage');
		$decode->pagePathtoID();
	}
	
	/*
	 * Delete the Cache for one Site. $parms['cacheCmd'] is the Page ID.
	 * This Funktion is a Hook function
	 *
	 * @return -
	 */
	function clearPageCache($parms, $this_ref){
		$page = (int)$parms['cacheCmd'];
		if(is_int($page) && $page > 0 ){
			$GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_flrealurlimage_cache', 'page_id = '.$page);
		}
	} # function - clearPageCache
	
	
	/*
	 * Redirect the RealURL Images
	 *
	 * @return -
	 */
	function pagePathtoID() {
		$parts = explode('/', t3lib_div::getIndpEnv('REQUEST_URI'));
		$path = $parts[sizeof($parts)-1];
		
		if($GLOBALS['fl_realurl_image']['simulateImageFolder'] != '' && isset($parts[sizeof($parts)-2]) && $parts[sizeof($parts)-2] != $GLOBALS['fl_realurl_image']['simulateImageFolder'])
			return;
				
		$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('image_path,tstamp','tx_flrealurlimage_cache','realurl_path=\''.$path.'\'', '', '', 1);
		if($GLOBALS['TYPO3_DB']->sql_num_rows($res) > 0){
			$data = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
			$info = getimagesize(PATH_site.$data['image_path']);
			
			if ($GLOBALS['fl_realurl_image']['cacheControl'] && $_SERVER['HTTP_IF_MODIFIED_SINCE']) {
				$lastGet = strtotime($_SERVER['HTTP_IF_MODIFIED_SINCE']);
				if ($data['tstamp'] != 0 && $lastGet <= $data['tstamp']){
					header("HTTP/1.1 304 Not Modified");
					die();
				} # if
			} # if

			header('Content-Type: '.$info['mime']);
			header('Content-Length: '.filesize(PATH_site.$data['image_path']));
			
			if($GLOBALS['fl_realurl_image']['cacheControl'] && $data['tstamp'] != 0) {
				header('Last-Modified: '.gmdate('D, d M Y H:i:s', $data['tstamp']) . ' GMT');           
			} # if
			
			readfile(PATH_site.$data['image_path']);
			die();
		} # if
	} # function
	
	/*
	 * Get the title of the page for the current language
	 *
	 * @return String Pagetitle
	 */
	function getLangTitle() {
		$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*','pages','uid='.$GLOBALS['TSFE']->id);
		$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
		$title = $row['title'];
		
		if ($GLOBALS['TSFE']->sys_language_content) {
			$OLmode = ($GLOBALS['TSFE']->sys_language_mode == 'strict'?'hideNonTranslated':'');
			$row = $GLOBALS['TSFE']->sys_page->getRecordOverlay('pages_language_overlay', $row, $GLOBALS['TSFE']->sys_language_content, $OLmode);
			if(isset($row['title'])) $title = $row['title'];
		} # if
		
		return $title;
	} # function
	
	/**
	 * Generate the RealUrl Path to an image:
	 *
	 * @param string The encoded base URL for this image
	 * @param string orginal path to picture z.B. typo3temp/pics/2305e38d9c.jpg
	 * @return string The ready RealUrl Path for the image
	 * @see rootLineToPath()
	 */
	function makeRealURLImgPath($realurl_base,$img_path) {
	
		$realurl_post = 0; // a postfix to get a unique realUrl
		list($img_base,$realurl_end) = explode('.',basename($img_path));
		$realurl_end = ".".$realurl_end;
		
		// if there is nothing sensible for a filename use a default (alternative: "return $img_path;" could make sense)
		if ($realurl_base == '')    $realurl_base = $img_base;
		
		do {
			
			//echo $realurl_base;
			$imageRealURL = ($realurl_post == 0)?$realurl_base.$realurl_end:$realurl_base.'-'.$realurl_post.$realurl_end;
			
			$res_realurl = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid,image_path','tx_flrealurlimage_cache','realurl_path=\''.$imageRealURL.'\'');
			$num_realurl = $GLOBALS['TYPO3_DB']->sql_num_rows($res_realurl);
			$data_realurl = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res_realurl);
			
			if ($num_realurl == 0){
				
				$insertArray = array(
					'crdate' => time(),
					'tstamp' => time(),
					'image_path' => $img_path,
					'realurl_path' => $imageRealURL,
					'pid' => intval($GLOBALS['fl_realurl_image']['recordStorage']),
					'page_id' => $GLOBALS['TSFE']->id
				);
				
				$res_realurl = $GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_flrealurlimage_cache', $insertArray);
				break;
				
			} elseif ($num_realurl == 1 && $data_realurl['image_path'] == $img_path)
				break;
			else     // URL taken by other picture          => look for free RealURL
				$realurl_post++;
				
		} while ($num_realurl == 1 && $data_realurl['image_path'] != $img_path);
		
		if($GLOBALS['fl_realurl_image']['simulateImageFolder'] != '')
			$imageRealURL = $GLOBALS['fl_realurl_image']['simulateImageFolder'].'/'.$imageRealURL;
		
		return $imageRealURL;
	} # function

} # class


if(defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fl_realurl_image/class.tx_flrealurlimage.php']){
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fl_realurl_image/class.tx_flrealurlimage.php']);
} // if
?>